// TCPReversiTCP_0.java

import ch.aplu.jgamegrid.*;
import ch.aplu.tcp.*;
import java.awt.*;
import java.util.*;
import javax.swing.JOptionPane;

public class TcpReversi_0 extends GameGrid implements GGMouseListener, TcpNodeListener
{
  int imageID = 0;
  private String sessionID = "xyzy&2011";
  private final String nickname = "reversi";
  private TcpNode tcpNode = new TcpNode();
  private boolean isMyMove = false;

  public TcpReversi_0()
  {
    super(8, 8, 60, Color.gray, false);
    setBgColor(Color.cyan);
    addStatusBar(30);

    Actor white = new Actor("sprites/playStone.png", 2);
    Actor white2 = new Actor("sprites/playStone.png", 2);
    Actor black = new Actor("sprites/playStone.png", 2);
    Actor black2 = new Actor("sprites/playStone.png", 2);
    addActor(white, new Location(3, 3));
    addActor(white2, new Location(4, 4));
    addActor(black, new Location(4, 3));
    addActor(black2, new Location(3, 4));
    white.show(0);
    white2.show(0);
    black.show(1);
    black2.show(1);

    addMouseListener(this, GGMouse.lPress);
    tcpNode.addTcpNodeListener(this);
    show();
    connect();
  }

  public boolean mouseEvent(GGMouse mouse)
  {
    
    return true;
  }

  //Checks if stone can be set and if neighboring stones can be turned
  public boolean checkStones(Location location)
  {
    return false;
  }

  //Checks if cell has at least on neighbour in the north, east, south or west
  private boolean hasNeighbours(Location location)
  {
    
    return false;
  }

  //Checks if board is full and counts score
  public boolean endOfGame()
  {
    
     return false;
  }

  private void connect()
  {
    String id = requestEntry("Enter unique session ID (more than 3 characters)");
    sessionID = sessionID + id;
    tcpNode.connect(id, nickname);
  }

  public void nodeStateChanged(TcpNodeState state)
  {
  }

  public void messageReceived(String sender, String text)
  {
    
  }

  public void statusReceived(String text)
  {
    if (text.contains("In session:--- (0)"))  // we are first player
    {
      setTitle("TCP - Reversi - BLACK");
      setStatusText("Connected. Wait for partner.");
    }
    else if (text.contains("In session:--- (1)")) // we are second player
    {
      setTitle("TCP - Reversi - WHITE");
      setStatusText("It's your move.");
      isMyMove = true;  // Second player starts
    }
    else if (text.contains("In session:--- ")) // we are next player
    {
      setStatusText("Game in progress. Terminating now...");
      TcpTools.delay(4000);
      System.exit(0);
    }
  }

  private String requestEntry(String prompt)
  {
    String entry = "";
    while (entry.length() < 3)
    {
      entry = JOptionPane.showInputDialog(null, prompt, "");
      if (entry == null)
        System.exit(0);
    }
    return entry.trim();
  }

  public static void main(String[] args)
  {
    new TcpReversi_0();
  }
}
